#include "mainwidget.h"
#include <QApplication>
#include <exception>

class MyApplication : public QApplication
{
public:
	MyApplication(int &argc, char ** argv);
private:
	bool notify(QObject *receiver_, QEvent *event_);
};

MyApplication::MyApplication(int& argc, char** argv) :
	  QApplication(argc, argv) {}



//////////////////////////////////////////////////////////////
bool MyApplication::notify(QObject* receiver, QEvent* event) 
{
bool done = true;
try {
	done = QApplication::notify(receiver, event);
	} 
catch (const std::exception& ex) 
	{
	cout << "std exception" << endl;
	} 
catch (TIPbusError &IPbusError) 
	{
	cout << "IPbus exception:" << IPbusError.Message.toStdString() << endl;
	}
catch (QString &str) 
	{
	cout << "QString exception:" << str.toStdString() << endl;
	
	}
return done;
} 
//////////////////////////////////////////////////////////////
int main(int argc, char** argv)
{
	//QApplication app(argc, argv);
MyApplication app(argc, argv);

MainWidget w; 
w.show();

return app.exec();
}

