library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity ipbus_dpram32 is
generic(ADDSIZE : natural:=13);
port(
	clk_in : in std_logic;
	wr_mem : in std_logic;
	add_in : in std_logic_vector(ADDSIZE-1 downto 0);
	data_in : in std_logic_vector(31 downto 0);

	clk_out : in std_logic;
	add_out : in std_logic_vector(ADDSIZE-1 downto 0);
	data_out : out std_logic_vector(31 downto 0)
	);
end ipbus_dpram32;

architecture RTL of ipbus_dpram32 is
type def_mem is array (0 to 2**ADDSIZE-1) of std_logic_vector(31 downto 0);
signal mem : def_mem;

begin
process(clk_in)
begin
	if rising_edge(clk_in) then
		if wr_mem='1' then
			mem(conv_integer(add_in))<=data_in;
		end if;
	end if;
end process;

process(clk_out)
begin
	if rising_edge(clk_out) then
		data_out<=mem(conv_integer(add_out));
	end if;
end process;
end RTL;



